#include <iostream>
#include <vector>
#include <ctime>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t number_count, bin_count, max_bin, height, answer = 0;
    double maxx, minn;
    cerr << "Enter number count: "; cin >> number_count; //Кол-во чисел
    vector <double> numbers(number_count);
    
    srand((unsigned int)42);
    cerr << "Use random numbers?(yes - 1/no - 0)\n"; cin >> answer;
    if (answer == 1)
    {
        for (int i = 0; i < number_count; i++)
        {
            cerr << "Enter Num[" << i << "]: "; numbers[i] = rand() % 9; //Ввод рандомных чисел
        }
    }
    else
    {
        for (int i = 0; i < number_count; i++)
        {
            cerr << "Enter Num[" << i << "]: "; cin >> numbers[i]; //Ввод чисел
        }
    }
    cerr << "Enter bin count: "; cin >> bin_count; //Кол-во корзин

    vector <size_t> bins(bin_count);
    maxx = numbers[0]; minn = numbers[1];
    for (size_t i = 0; i < number_count; i++)
    {
        if (maxx < numbers[i])
            maxx = numbers[i];
        if (minn > numbers[i])
            minn = numbers[i];
    }
    
    double bin_size = (maxx - minn) / bin_count;
    
    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = minn + j * bin_size;
            auto hi = minn + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    max_bin = bins[0];
    height = bins[0];
    for (size_t i = 0; i < bin_count; i++)
    {
        if (bins[i] > max_bin)
            max_bin = bins[i];
    }
    
    for (size_t i = 0; i < bin_count; i++)
    {
        if (bins[i] < 100)
            cout << " ";
        if (bins[i] < 10)
            cout << " ";
        cout << bins[i] << "|";
        height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_bin);
        for (size_t j = 0; j < height; j++)
        {
            cout << "*";
        }
        cout << endl;
    }
    return 0;
}
